"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DocumentLock {
    constructor() {
        this.locks = new Map();
    }
    getLocks() {
        return Array.from(this.locks.keys());
    }
    async lock(collection = "", document = "") {
        //TODO: Check collection locks
        let key = collection + "/" + document;
        let l = this.locks.get(key);
        if (l)
            await new Promise((resolve) => {
                l.push(resolve);
                this.locks.set(key, l);
            });
        else {
            l = [];
            this.locks.set(key, l);
        }
        return () => {
            if (l.length > 0)
                setImmediate(() => l.shift()());
            else
                this.locks.delete(key);
        };
    }
}
exports.default = DocumentLock;
//# sourceMappingURL=lock.js.map